---------------------------------------------------------------------------------------------------------
-- @Author: ViperGTS96-----------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
--------------------"The simplest design is the best design." -------------------------------------------
---------------------------------------------------------------------------------------------------------
-----The ability to add Masks/Hats/Helmets to player via this script is reserved by ViperGTS96-----------
---------------------------------------------------------------------------------------------------------

santaHat = {}
santaHat.path = g_currentModDirectory;
santaHat.dir = santaHat.path.."models/";
local modDescFile = loadXMLFile("modDesc", santaHat.path .. "modDesc.xml");
santaHat.title = getXMLString(modDescFile, "modDesc.title.en");
santaHat.author = getXMLString(modDescFile, "modDesc.author");
santaHat.version = getXMLString(modDescFile, "modDesc.version");
santaHat.aiGetHats = Utils.getNoNil(getXMLBool(modDescFile, "modDesc.helperHats.aiGetHats#value"),true);
santaHat.aiElfHats = Utils.getNoNil(getXMLBool(modDescFile, "modDesc.helperHats.useElfHats#value"),true);
delete(modDescFile);
santaHat.hatFilename = {"santaHat.i3d","elfHat.i3d"};
santaHat.plyrModel = 1;
santaHat.glovesFilename = "";
santaHat.equipGloves = false;
santaHat.isHelperHat = false;

-----------------------------------
print("Load mod: "..santaHat.title.." : v"..santaHat.version.." by "..santaHat.author);
-----------------------------------

PlayerStyle.setHat = function(self, hatIndex)

    local result = false;
	
	if self.player ~= nil and self.playerHatNode ~= nil then

		if self.hatNode ~= nil then self:removeHat(); end;
		local modelIndex = santaHat.plyrModel;
		if (santaHat.aiGetHats and santaHat.isHelperHat) or not santaHat.isHelperHat then
			if (santaHat.isHelperHat and santaHat.aiElfHats) then modelIndex = 2; end;
			self.hatNode = loadI3DFile(santaHat.dir..santaHat.hatFilename[modelIndex], false, false, false);
		end;

		if self.hatNode ~= nil then
			self:setHair(0, true);
			link(self.playerHatNode, self.hatNode);
			self.selectedHatIndex = hatIndex;
			result = true;
		end;
	else
		g_logManager:devError("-- [PlayerStyle:setHat] Player not set. Missing call to PlayerStyle:loadXML().")
	end;
	--[[
	if santaHat.equipGloves then
		if self.protection.glovesNode ~= nil then
			local gloves = self.protection.glovesNode;
			--ConfigurationUtil.replaceMaterialRec(gloves, gloves, getMaterial(gloves, 0), getMaterial(sHatShape, 0))
			--gloves = loadI3DFile(santaHat.dir..santaHat.glovesFilename, false, false, false); --requires skin bindings
			setVisibility(gloves, true);
		end;
    end;
	]]--
	santaHat.isHelperHat = false;
    return result;

end;

Enterable.setRandomVehicleCharacter = function(self)
    local spec = self.spec_enterable;
    if spec.vehicleCharacter ~= nil then
		if not santaHat.isHelperHat then
			santaHat.isHelperHat = true;
		end;
        local aiPlayerModelIndex = math.random(1, g_playerModelManager:getNumOfPlayerModels());
        local playerModel = g_playerModelManager:getPlayerModelByIndex(aiPlayerModelIndex);
        self:setVehicleCharacter(playerModel.xmlFilename, PlayerStyle:new());
        local aiStyle = self:getCurrentPlayerStyle();
        local oldStyle = self:getUserPlayerStyle();
        local numOfBodys = #aiStyle.bodies;
        local aiBodyIndex = math.random(1, numOfBodys);
        if oldStyle ~= nil then
            if aiStyle.selectedModelIndex == oldStyle.selectedModelIndex then
                local oldBodyIndex = oldStyle.selectedBodyIndex;
                if numOfBodys > 1 then
                    while aiBodyIndex == oldBodyIndex do
                        aiBodyIndex = math.random(1, numOfBodys);
                    end;
                end;
            end;
        end;
        aiStyle:setBody(aiBodyIndex);
        aiStyle:setColor(math.random(1, #g_playerColors));
		if not santaHat.aiGetHats then		
			aiStyle:setHair(math.random(1, #aiStyle.hairs.styles))
		end;
        aiStyle:setJacket(math.random(0, #aiStyle.jackets));
    end;
end;

function santaHat:loadMap(savegame)
	Player.onLeaveVehicle = Utils.appendedFunction(santaHat.updateThirdPersonHat, Player.onLeaveVehicle);	
end;

function santaHat:updateThirdPersonHat()
	if self.playerCamera2 ~= nil then
		if self.visualInformation ~= nil then
			if self.visualInformation.hatNode ~= nil then
				self.visualInformation.hatNode = loadI3DFile(santaHat.dir..santaHat.hatFilename[santaHat.plyrModel], false, false, false);				
				link(self.visualInformation.playerHatNode, self.visualInformation.hatNode);
				if santaHat.isHelperHat then
					if not santaHat.aiGetHats then
						self:removeHat();
					end;
					santaHat.isHelperHat = false;
				end;
			end;
		end;
	end;
end;

addModEventListener(santaHat);